﻿/**
math class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
!!!This methods were decleared as global functions because the flash Math class could not be extended by prototyping it
*/

trace("flashclass extension <math as _global functions> loaded");

_global.math_dist = function(): Number {
	var _point1:Array = arguments[0];
	var _point2:Array = arguments[1];
	
	return Math.sqrt(Math.pow(_point2[0] - _point1[0], 2) + Math.pow(_point2[1] - _point1[1], 2));
}

_global.math_approx = function() {
	var _number:Number = arguments[0];
	var _afterComa:Number = arguments[1];
	
	return Math.round(_number * Math.pow(10, _afterComa)) / Math.pow(10, _afterComa);
}

_global.math_rowsum = function () {
	var begin = (arguments[1] == undefined) ? 1 : arguments[1];
	var end = arguments[0];
	return (begin + end) * Math.floor((end - begin + 1) / 2) + ((begin + end) / 2) * ((end - begin + 1) % 2);
}

_global.math_rndHex = function(p_length) {
	
	var hexChars = "0123456789ABCDEF";
	var hexString = "";
	
	for(var i = 0; i < p_length; i++) {
		
		hexString += hexChars.charAt(Math.floor(Math.random() * hexChars.length)).toString();
		
	}
	
	return hexString;
	
}
