/**
array class extension written by Vu Duong <vu.duong@masterpiece-softworks.de>

:::How to use:::
Include this file to your flash to get access to the additional class methods.
To use all class extensions read the instruction in the flashclass_extension.as file
*/

trace("flashclass extension <array> loaded");

Array.prototype.copy = function() {
	return this.join("#|#").split("#|#");
}

Array.prototype.removeByValue = function() {
	var value = arguments[0];
	var found = false;
	for(var i = 0; i < this.length; i++) {
		if(this[i] == value) {
			found = true;
			this.splice(i, 1);
		}
	}
}

Array.prototype.insertUnique = function() {
	var value = arguments[0];
	var _sep = "#|#";
	var _parsArr = _sep + this.join(_sep) + _sep;
	var _parsStr = _sep + value + _sep;
	if(_parsArr.indexOf(_parsStr) == -1) {
		this.push(value);
	}
}

Array.prototype.getIndexesByValue = function() {
	var _exp = arguments[0];
	var _case = (arguments[1] == undefined) ? false : arguments[1];
	if(!_case) _exp = _exp.toLowerCase();
	var arr_indexes = new Array();
	for(var i = 0; i < this.length; i++) {
		var _value = this[i];
		if(!_case) _value = _value.toLowerCase();
		if(_value == _exp) arr_indexes.push(i);
	}
	return arr_indexes;
}

ASSetPropFlags(Array.prototype, "copy", 1);
ASSetPropFlags(Array.prototype, "removeByValue", 1);
ASSetPropFlags(Array.prototype, "insertUnique", 1);
ASSetPropFlags(Array.prototype, "getIndexesByValue", 1);
